void lorentz(double *u,double *p1,double *p1prime);

void BjorkenBoost(int nparts,Tpartinfo **&newparts,CParameter &parm){
  double u[4],pboost[4],y,yt;
  int alpha,ipart;
  yt=parm.ytmax*(1.0-2.0*ranptr->ran());
  y=parm.etamax*(1.0-2.0*ranptr->ran());
  u[1]=sinh(yt);
  u[3]=sinh(y);
  u[2]=0.0;
  u[0]=sqrt(1.0+u[1]*u[1]+u[2]*u[2]+u[3]*u[3]);
  for(ipart=0;ipart<nparts;ipart++){
    lorentz(u,newparts[ipart]->p,pboost);
    for(alpha=0;alpha<4;alpha++) newparts[ipart]->p[alpha]=pboost[alpha];
  }
}

void lorentz(double *u,double *p1,double *p1prime){
  static double n[4]={1.0,0.0,0.0,0.0};
  static double g[4]={1.0,-1.0,-1.0,-1.0};
  int mu;
  double udotn=0.0,p1dotn=0.0,p1dotu=0.0;
  for(mu=0;mu<4;mu++){
    p1dotn=p1dotn+p1[mu]*n[mu]*g[mu];
    p1dotu=p1dotu+p1[mu]*u[mu]*g[mu];
    udotn=udotn+u[mu]*n[mu]*g[mu];
  }
  for(mu=0;mu<4;mu++){
    p1prime[mu]=-((p1dotu+p1dotn)/(1.0+udotn))*(n[mu]+u[mu])
      +2.0*p1dotn*u[mu]+p1[mu];
  }
}
