// If masses might be different, you should add the 'delmterm' statements
void decompose(double *pa,double *pb,double &qlong,double &qout,double &qside,
               double &qinv,double &delrap){
  double pt,s,Mlong,roots;
  //double delmterm;
  double ptot[4],q[4],rapa,rapb;
  const int g[4]={1,-1,-1,-1};
  int alpha;
  qinv=0.0;
  s=0.0;
  //delmterm=0.0;
  for(alpha=0;alpha<4;alpha++){
    ptot[alpha]=pa[alpha]+pb[alpha];
    s+=g[alpha]*ptot[alpha]*ptot[alpha];
    //delmterm+=g[alpha]*ptot[alpha]*(pa[alpha]-pb[alpha]);
  }
  //delmterm=delmterm/s;
  for(alpha=0;alpha<4;alpha++){
    q[alpha]=pa[alpha]-pb[alpha];
    //q[alpha]-=ptot[alpha]*delmterm;
    qinv-=g[alpha]*q[alpha]*q[alpha];
  }
  pt=sqrt(ptot[1]*ptot[1]+ptot[2]*ptot[2]);
  Mlong=sqrt(s+pt*pt);
  roots=sqrt(s);

  qside=(ptot[1]*q[2]-ptot[2]*q[1])/pt;
  qlong=(ptot[0]*q[3]-ptot[3]*q[0])/Mlong;
  qout=(roots/Mlong)*(ptot[1]*q[1]+ptot[2]*q[2])/pt;

  qinv=sqrt(qinv);

  rapa=0.5*log((pa[0]+pa[3])/(pa[0]-pa[3]));
  rapb=0.5*log((pb[0]+pb[3])/(pb[0]-pb[3]));
  delrap=fabs(rapa-rapb);
  //printf("Test: qinv=%g, q^2=%g\n",
  // qinv,sqrt(qside*qside+qout*qout+qlong*qlong));

}


