void mc(int nevents,double Tkinetic,charge& Q,double *Aprob,
	partition_function& F,particle_zoo &zoo,string filename){
  charge totalcharge,newcharge,testQ;
  const particle *kpart_ptr;
  list<const particle *> particlelist;
  list<const particle *>::const_iterator particle_it;  
  int alpha,nres,nprint;
  double randy,sum,Ztest,weight,Ztot;
  double p[4],mass;
  particle_zoo::const_iterator k;
  int ievent,totala,newa;
  ofstream outfile;
  outfile.open(filename.c_str());

  // Performing test of partition functions
  sum=0.0;
  totala=10;
  for(k=zoo.begin();k!=zoo.end();++k){
    kpart_ptr=&*k;
    //cout << "Inside mc, ID=" << kpart_ptr->its_ID 
    //	 << ", name=" << kpart_ptr->its_Name 
    //	 << ", mass=" << kpart_ptr->its_Mass << endl;
    newcharge=Q-kpart_ptr->its_charge;
    newa=totala-kpart_ptr->its_A;
    sum+=kpart_ptr->its_W*F.getZ(newa,newcharge)*kpart_ptr->its_A/double(totala);
  }
  cout << "CHECK:" << setprecision(14) << setw(14) << sum/F.getZ(totala,Q) 
       << " =? 1\n";
  outfile << nevents << endl;

  nprint=0;
  for(ievent=0;ievent<nevents;ievent++){
    if(nevents/10==ievent+1-nevents*nprint/10){
      printf("Finished %d of %d events\n",ievent+1,nevents);
      nprint+=1;
    }
    totalcharge=Q;

    randy=ranptr->ran();
    sum=0.0;
    totala=-1;
    do{
      totala+=1;
      sum+=Aprob[totala];
    }while(randy>sum);
    //cout << "will make event with totala=" << totala << endl;

    while(totala>0){
      Ztot=F.getZ(totala,totalcharge);

      randy=ranptr->ran();
      sum=0.0;
      for(k=zoo.begin();k!=zoo.end();++k){
	kpart_ptr=&*k;
	if(kpart_ptr->its_A<=totala){
	  newa=totala-kpart_ptr->its_A;
	  newcharge=totalcharge-kpart_ptr->its_charge;
	  Ztest=F.getZ(newa,newcharge);
	  sum+=kpart_ptr->its_W*Ztest*kpart_ptr->its_A/double(totala);
	}
	if(sum>randy*Ztot) goto MC_SUCCESS;
      }
      cout << "You shouldn't be here, MC has failed\n";
      exit(1);

    MC_SUCCESS:
      particlelist.push_back(kpart_ptr);
      totalcharge=newcharge;
      totala=newa;
    }
    outfile << particlelist.size() << endl;
    for(particle_it=particlelist.begin();particle_it!=particlelist.end();
	++particle_it){
      kpart_ptr=*particle_it;
      //mass=kpart_ptr->its_Mass;
      //getp(Tkinetic,mass,p);
      getpm(Tkinetic,kpart_ptr->its_Mass,kpart_ptr->its_width,
	    kpart_ptr->its_ID,p);
      outfile << kpart_ptr->its_ID;
      for(alpha=1;alpha<4;alpha++) outfile << " " << p[alpha];
      //outfile << " " << sqrt(p[0]*p[0]-p[1]*p[1]-p[2]*p[2]-p[3]*p[3]);
      outfile << endl;
    }
    particlelist.clear();
  }
  outfile.clear();
  outfile.close();
  
}

void getpm(double temperature,double mass, double width,int id,double *p){
  double m,minmass,weight,pmag,w0,ctheta,stheta,phi,e;
  const double PI=4.0*atan(1.0);

  if(width<1.0){
    getp(temperature,mass,p);
  }
  else{
    minmass=getminmass(id);
    w0=exp(width/temperature);
  GETPR_TRYAGAIN_REL:
    m=mass-4.0*width+8.0*width*ranptr->ran();
    if(m<minmass) goto GETPR_TRYAGAIN_REL;
    getp(temperature,mass,p);
    weight=0.25*width*width/(pow(mass-m,2)+0.25*width*width);
    e=sqrt(m*m+p[1]*p[1]+p[2]*p[2]+p[3]*p[3]);
    weight=weight*exp(-(e-p[0])/temperature);
    if(weight<w0*ranptr->ran()) goto GETPR_TRYAGAIN_REL;
    p[0]=e;
  }
}
void testgetpm(double temperature,double mass, double width,int id,double *p){
  double m,minmass,weight,pmag,w0,ctheta,stheta,phi,e;
  const double PI=4.0*atan(1.0);

  if(width<1.0){
    getp(temperature,mass,p);
  }
  else{
    minmass=getminmass(id);
    w0=exp(width/temperature);
    m=mass-4.0*width+8.0*width*ranptr->ran();
    getp(temperature,mass,p);
    e=sqrt(m*m+p[1]*p[1]+p[2]*p[2]+p[3]*p[3]);
    p[0]=e;
  }
}
