CParameter::CParameter(string filename){
  Tkinetic=120.0;
  Tchem=175.0;
  Vchem=64.0;
  AMAX=50;
  resonances_qualifier="allresonances";
  ReadPars(filename);
}

void CParameter::ReadPars(string filename){
  ifstream infile;
  string key;
  string value;
  infile.open(filename.c_str());
  while(infile >> key >> value){
    if(key=="Tchem") Tchem=atof(value.c_str());
    else if(key=="Vchem") Vchem=atof(value.c_str());
    else if(key=="Tkinetic") Tkinetic=atof(value.c_str());
    else if(key=="resonances_qualifier") resonances_qualifier=value;
    else if(key=="AMAX") AMAX=atoi(value.c_str());
    else cout << "Parameter Keyword " << key << " not recognized" << endl;
  }
  cout << "__PARAMETERS__" << endl;
  cout << "Tchem=" << Tchem << ", Vchem=" << Vchem << ", AMAX=" << AMAX << endl;
  cout << "Tkinetic=" << Tkinetic << endl;
  cout << "resonances_qualifier=" << resonances_qualifier << endl;
  cout << "____________________________________________" << endl;

  infile.close();
}

