//===========================================================
//  PARTICLEZOO.H
//  
//  provides basic functionality for handling an elementary
//  set of particles

#ifndef __PARTICLEZOO__H__INCLUDED__
#define __PARTICLEZOO__H__INCLUDED__

using namespace std; 

class XFileNotFound
{
public: 
  XFileNotFound() {};
};


struct particle
{
  int                  its_A;
  double		its_Mass;
  double               its_W;
  string	        its_Name;
  charge               its_charge;
  int                  its_ID;
  double               its_width;
};

struct environment
{
   double   its_temperature;
   double   its_volume;
};


class particle_zoo : public vector<particle> {
 public:
  particle_zoo(environment& a_environment) : env(a_environment) {};
    int getMaxA() const;  
    void read_from_file(string filename, int skiplines = 0);
    void set_env_conditions(const environment& env_cond);
    const environment& get_env_conditions() const;
    void  update_partitions(); // manual update
 private:
    particle_zoo() {};  // do not allow parameterless construction

    environment env;
};

#endif // __PARTICLEZOO__H__INCLUDED__
