Tresinfo::Tresinfo(){
  count=0;
  nextresinfoptr=NULL;
  firstbptr=NULL;
}

void Tresinfo::DecayGetresinfoptr(int &nbodies,
		     Tresinfo **&daughterresinfoptr){
  double randy,bsum;
  int ibody;
  Tbranchinfo *bptr;
  bptr=NULL;
  bsum=0.0;
  randy=ranptr->ran();

  do{
    if(bptr==NULL){
      bptr=firstbptr;
    }
    else{
      bptr=bptr->nextbptr;
    }
    bsum+=bptr->branching;
    if(bsum-1.0>1.0E-6){
      cout << "In DecayGetresinfo: bsum too large, = " << bsum << endl;
      exit(1);
    }
    
  }while(bsum<randy);
  
  nbodies=bptr->nbodies;
  for(ibody=0;ibody<nbodies;ibody++){
    daughterresinfoptr[ibody]=bptr->resinfoptr[ibody];
  }

}

Tbranchinfo::Tbranchinfo(){
  nextbptr=NULL;
}

Tpartinfo::Tpartinfo(){
  int alpha;
  for(alpha=0;alpha<4;alpha++) p[alpha]=0.0;
}
Tpartinfo::~Tpartinfo(){
  //delete [] p;
}

void Treslist::ReadResInfo(){
  int mothercode,code,decay,strange,charge,baryon;
  double mass,mothermass,spin,width,bsum;
  int ichannel,nchannels,ibody,nbodies,length;
  int netq,netb,nets;
  char dummy[120],name[50];
  Tresinfo *resinfoptr=NULL,*oldresinfoptr=NULL;
  Tbranchinfo *bptr=NULL,*oldbptr=NULL;
  ifstream resinfofile;

  resinfofile.open("../particleinfo/allresonances_withgamma.dat");
  resinfofile.getline(dummy,100);
  
  while(resinfofile >> code){
    resinfofile >> mass >> charge >> baryon >> strange >> spin 
		>> decay >> width >> name;
    resinfofile.getline(dummy,100);
    resinfoptr=new Tresinfo();
    if(oldresinfoptr==NULL){
      Gfirstresinfoptr=resinfoptr;
    }
    else{
      oldresinfoptr->nextresinfoptr=resinfoptr;
    }
    resinfoptr->code=code;
    resinfoptr->mass=mass;
    resinfoptr->charge=charge;
    resinfoptr->baryon=baryon;
    resinfoptr->strange=strange;
    resinfoptr->spin=spin;
    resinfoptr->decay=decay;
    resinfoptr->width=width;    
    strcpy(resinfoptr->name,name);
    /* cout << "name=" << name << ":\n";
       cout << "code=" << resinfoptr->code << ", M=" << resinfoptr->mass
	 << ", Q=" << resinfoptr->charge << ", B=" << resinfoptr->baryon
	 << ", S=" << resinfoptr->strange << ", s=" << resinfoptr->spin
	 << ", decay=" << resinfoptr->decay 
	 << ", W=" << resinfoptr->width << endl; */
    
    oldresinfoptr=resinfoptr;
  }
  resinfofile.close();

  //cout << "RESONANCES READ, WILL BEGIN READING DECAY INFO\n";

  resinfofile.clear();
  resinfofile.open("../particleinfo/decayinfo.dat");
  
  while(resinfofile >> mothercode >> mothermass){
    resinfofile.getline(dummy,80);
    resinfofile >> mothercode >> nchannels;
    Getresinfoptr(mothercode,resinfoptr);
    bsum=0.0;

    for(ichannel=0;ichannel<nchannels;ichannel++){
      bptr=new Tbranchinfo();
      if(ichannel==0){
	resinfoptr->firstbptr=bptr;
      }
      else{
	oldbptr->nextbptr=bptr;
      }
      resinfofile >> bptr->nbodies;
      netq=-resinfoptr->charge;
      netb=-resinfoptr->baryon;
      nets=-resinfoptr->strange;

      for(ibody=0;ibody<bptr->nbodies;ibody++){
	resinfofile >> code;
	Getresinfoptr(code,bptr->resinfoptr[ibody]);
	netq+=bptr->resinfoptr[ibody]->charge;
	netb+=bptr->resinfoptr[ibody]->baryon;
	nets+=bptr->resinfoptr[ibody]->strange;
      }
      if(netq!=0 || netb!=0 || nets!=0){
	cout << "netq=" << netq << ", netb=" << netb <<", nets=" << nets <<endl;
	cout << "mother=" << resinfoptr->name 
	     << "(" << resinfoptr->code << "), "
	     << "strangeness=" << resinfoptr->strange << ", ichannel="
	     << ichannel << endl;
	cout << "DAUGHTERS: ";
	for(ibody=0;ibody<bptr->nbodies;ibody++){
	  cout << bptr->resinfoptr[ibody]->name << ", s=" 
	       << bptr->resinfoptr[ibody]->strange << endl;
	}
	cout << endl;
	exit(1);
      }
      resinfofile >> bptr->branching;
      bsum+=bptr->branching;
      oldbptr=bptr;
    }
    //cout << form("%s: branch sum=%g\n",resinfoptr->name,bsum);
    
  }
  resinfofile.close();
}

void Treslist::Getresinfoptr(int code,Tresinfo *&resinfoptr){
  resinfoptr=Gfirstresinfoptr;
  while(resinfoptr->code!=code){
    resinfoptr=resinfoptr->nextresinfoptr;
    if(resinfoptr==NULL){
      cout << "failure to identify code=" << code << endl;
      exit(1);
    }
  }
}

void Treslist::PrintYields(){
  Tresinfo *resinfoptr;
  cout << "_____________________\n     YIELDS\n";
  resinfoptr=Gfirstresinfoptr;
  while(resinfoptr!=NULL){
    cout << resinfoptr->name << ": " << resinfoptr->count << endl;
    resinfoptr=resinfoptr->nextresinfoptr;
  }
}
