CRandom::CRandom(int seed){
  IDUM=-1-abs(seed);
  IDUM2=123456789;
  IY=0;
  NTAB=32;
  IV=new int[NTAB];
}

void CRandom::reset(int seed){
  IDUM=-1-abs(seed);
}

/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

/* long IDUM=-123 */
/* double ran2(void); */
/* double gauss(void); */
/* void gauss2(double *randy1,double *randy2); */

/* To use this routine, call the ran2 with the form */
/*   x=ran2();  */
/* and x will be a random number between 0 and 1, which won't repeat */
/* before every 10^18 numbers */
/* To initialize, call with IDUM being a NEGATIVE number */
/* This came out of the ran2 function from numerical recipes */

double CRandom::ran() {
  const int IM1=2147483563;
  const int IM2=2147483399;
  const double AM=1.0/double(IM1);
  const int IMM1=IM1-1;
  const int IA1=40014;
  const int IA2=40692;
  const int IQ1=53668;
  const int IQ2=52774;
  const int IR1=12211;
  const int IR2=3791;
  const int NDIV=(1+IMM1/NTAB);
  const double EPS=1.2e-12;
  const double RNMX=(1.0-EPS);
  long J;
  long K;
  double tempguy;
  if(IDUM <=0){
    if(-(IDUM)<1) IDUM=1;
    else IDUM = -(IDUM);
    IDUM2=(IDUM);
    for (J=NTAB+7;J>=0;J--) {
      K=(IDUM)/IQ1;
      IDUM=IA1*(IDUM-K*IQ1)-K*IR1;
      if(IDUM<0) IDUM +=IM1;
      if(J<NTAB) IV[J]=IDUM;
    }
    IY=IV[0];
    //printf("Initialization Completed %d\n",IDUM);
  }
  K=(IDUM)/IQ1;
  IDUM=IA1*(IDUM-K*IQ1)-K*IR1;
  if(IDUM<0) IDUM+=IM1;
  K=IDUM2/IQ2;
  IDUM2=IA2*(IDUM2-K*IQ2)-K*IR2;
  if(IDUM2<0) IDUM2+=IM2;
  J=IY/NDIV;
  IY=IV[J]-IDUM2;
  IV[J]=IDUM;
  if(IY<1) IY+=IMM1;
  tempguy=AM*IY;
  if(tempguy>RNMX) return RNMX;
  else return tempguy;
}

double CRandom::gauss(){
  double x,y,r2,r,c,randy;
 TRY_AGAIN:
  x=1.0-2.0*ran();
  y=1.0-2.0*ran();
  r2=x*x+y*y;
  if(r2>1.0) goto TRY_AGAIN;
  r=sqrt(r2);
  c=x/r;
  randy=c*sqrt(-2.0*log(r2));
  return randy;
}

void CRandom::gauss2(double *randy1,double *randy2){
  double x,y,r2,r,c,s,randy;
 TRY_AGAIN:
  x=1.0-2.0*ran();
  y=1.0-2.0*ran();
  r2=x*x+y*y;
  if(r2>1.0) goto TRY_AGAIN;
  r=sqrt(r2);
  c=x/r;
  s=y/r;
  *randy1=c*sqrt(-2.0*log(r2));
  *randy2=(s/c)**randy1;
}

